window.Gleam.initSearch([{"doc":"glib","title":"glib","content":"# glib\n\nA collection (eventually) of utilities written solely in Gleam (i.e. no erlang/js dependency)\n\n[![Package Version](https://img.shields.io/hexpm/v/glib)](https://hex.pm/packages/glib)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glib/)\n\n```sh\ngleam add glib\n```\n```gleam\nimport glib/map\n\npub fn main() {\n  let m = map.new()\n  |&gt; map.put(&quot;Key1&quot;,&quot;value&quot;)\n\n  io.debug(map.get(m, &quot;Key1&quot;))\n  // -&gt; Some(&quot;value&quot;)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glib&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"glib/fraction","title":"Fraction","content":"pub type Fraction {\n  Fraction(numerator: Int, denominator: Int)\n}\n\nFraction(numerator: Int, denominator: Int)\n\n\nSynonyms:\nglib/fraction.Fraction\nglib/fraction Fraction","url":"glib/fraction.html#Fraction"},{"doc":"glib/fraction","title":"FractionError","content":"pub type FractionError {\n  ZeroDenominator(a: String)\n  Overflow(a: String)\n  TooLarge(a: String)\n  ConversionError(a: String)\n  DivideByZero(a: String)\n}\n\nZeroDenominator(a: String)\n\n\nOverflow(a: String)\n\n\nTooLarge(a: String)\n\n\nConversionError(a: String)\n\n\nDivideByZero(a: String)\n\n\nSynonyms:\nglib/fraction.FractionError\nglib/fraction FractionError","url":"glib/fraction.html#FractionError"},{"doc":"glib/fraction","title":"abs","content":"pub fn abs(fr: Fraction) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.abs\nglib/fraction abs","url":"glib/fraction.html#abs"},{"doc":"glib/fraction","title":"add","content":"pub fn add(\n  fr1: Fraction,\n  fr2: Fraction,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.add\nglib/fraction add","url":"glib/fraction.html#add"},{"doc":"glib/fraction","title":"compare","content":"pub fn compare(fr1: Fraction, fr2: Fraction) -&gt; Order\n\nSynonyms:\nglib/fraction.compare\nglib/fraction compare","url":"glib/fraction.html#compare"},{"doc":"glib/fraction","title":"denominator","content":"pub fn denominator(fr1: Fraction) -&gt; Int\n\nSynonyms:\nglib/fraction.denominator\nglib/fraction denominator","url":"glib/fraction.html#denominator"},{"doc":"glib/fraction","title":"divide","content":"pub fn divide(\n  fr1: Fraction,\n  fr2: Fraction,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.divide\nglib/fraction divide","url":"glib/fraction.html#divide"},{"doc":"glib/fraction","title":"equals","content":"pub fn equals(fr1: Fraction, fr2: Fraction) -&gt; Bool\n\nSynonyms:\nglib/fraction.equals\nglib/fraction equals","url":"glib/fraction.html#equals"},{"doc":"glib/fraction","title":"from_float","content":"pub fn from_float(num: Float) -&gt; Result(Fraction, FractionError)\n Generates a Fraction from given float\n Returns error if number is larger than\n the max int value\n \n ## Examples\n \n \n let fr = from_float(0.75)\n // -&gt; Ok(Fraction(3, 4))\n \n \n \n let fr = from_float(0.66666)\n // -&gt; Ok(Fraction(2, 3))\n \n \nSynonyms:\nglib/fraction.from_float\nglib/fraction from_float","url":"glib/fraction.html#from_float"},{"doc":"glib/fraction","title":"from_string","content":"pub fn from_string(\n  fraction: String,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.from_string\nglib/fraction from_string","url":"glib/fraction.html#from_string"},{"doc":"glib/fraction","title":"inverse","content":"pub fn inverse(fr1: Fraction) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.inverse\nglib/fraction inverse","url":"glib/fraction.html#inverse"},{"doc":"glib/fraction","title":"multiply","content":"pub fn multiply(\n  fr1: Fraction,\n  fr2: Fraction,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.multiply\nglib/fraction multiply","url":"glib/fraction.html#multiply"},{"doc":"glib/fraction","title":"negate","content":"pub fn negate(fr: Fraction) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.negate\nglib/fraction negate","url":"glib/fraction.html#negate"},{"doc":"glib/fraction","title":"new","content":"pub fn new(\n  numerator: Int,\n  denominator: Int,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.new\nglib/fraction new","url":"glib/fraction.html#new"},{"doc":"glib/fraction","title":"new2","content":"pub fn new2(\n  whole: Int,\n  numerator: Int,\n  denominator: Int,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.new2\nglib/fraction new2","url":"glib/fraction.html#new2"},{"doc":"glib/fraction","title":"numerator","content":"pub fn numerator(fr1: Fraction) -&gt; Int\n\nSynonyms:\nglib/fraction.numerator\nglib/fraction numerator","url":"glib/fraction.html#numerator"},{"doc":"glib/fraction","title":"power","content":"pub fn power(\n  fr1: Fraction,\n  pow: Int,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.power\nglib/fraction power","url":"glib/fraction.html#power"},{"doc":"glib/fraction","title":"proper_numerator","content":"pub fn proper_numerator(fr1: Fraction) -&gt; Int\n\nSynonyms:\nglib/fraction.proper_numerator\nglib/fraction proper_numerator","url":"glib/fraction.html#proper_numerator"},{"doc":"glib/fraction","title":"proper_whole","content":"pub fn proper_whole(fr1: Fraction) -&gt; Int\n\nSynonyms:\nglib/fraction.proper_whole\nglib/fraction proper_whole","url":"glib/fraction.html#proper_whole"},{"doc":"glib/fraction","title":"reduce","content":"pub fn reduce(fr: Fraction) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.reduce\nglib/fraction reduce","url":"glib/fraction.html#reduce"},{"doc":"glib/fraction","title":"sub","content":"pub fn sub(\n  fr1: Fraction,\n  fr2: Fraction,\n) -&gt; Result(Fraction, FractionError)\n\nSynonyms:\nglib/fraction.sub\nglib/fraction sub","url":"glib/fraction.html#sub"},{"doc":"glib/fraction","title":"to_float","content":"pub fn to_float(fr1: Fraction) -&gt; Float\n\nSynonyms:\nglib/fraction.to_float\nglib/fraction to_float","url":"glib/fraction.html#to_float"},{"doc":"glib/fraction","title":"to_int","content":"pub fn to_int(fr1: Fraction) -&gt; Int\n\nSynonyms:\nglib/fraction.to_int\nglib/fraction to_int","url":"glib/fraction.html#to_int"},{"doc":"glib/fraction","title":"to_proper_string","content":"pub fn to_proper_string(fr1: Fraction) -&gt; String\n\nSynonyms:\nglib/fraction.to_proper_string\nglib/fraction to_proper_string","url":"glib/fraction.html#to_proper_string"},{"doc":"glib/fraction","title":"to_string","content":"pub fn to_string(fr1: Fraction) -&gt; String\n\nSynonyms:\nglib/fraction.to_string\nglib/fraction to_string","url":"glib/fraction.html#to_string"},{"doc":"glib/fraction","title":"glib/fraction","content":" General Fraction functions\n Fraction type allow for accurate storage and manipulation\n of fractions\n \n There is a current limitation of 9007199254740991 for the \n numerator and denominator. This is because this is the largest\n &#39;safe&#39; integer in Javascript.","url":"glib/fraction.html"},{"doc":"glib/hash","title":"hash","content":"pub fn hash(value: String) -&gt; Int\n\nSynonyms:\nglib/hash.hash\nglib/hash hash","url":"glib/hash.html#hash"},{"doc":"glib/hash","title":"glib/hash","content":"","url":"glib/hash.html"},{"doc":"glib/treelist","title":"Node","content":"pub opaque type Node(value)\n\n\nSynonyms:\nglib/treelist.Node\nglib/treelist Node","url":"glib/treelist.html#Node"},{"doc":"glib/treelist","title":"TreeList","content":"pub opaque type TreeList(value)\n\n\nSynonyms:\nglib/treelist.TreeList\nglib/treelist TreeList","url":"glib/treelist.html#TreeList"},{"doc":"glib/treelist","title":"add","content":"pub fn add(\n  list: TreeList(a),\n  value: a,\n) -&gt; Result(TreeList(a), Nil)\n Adds an element to the end of the provided treelist\n i.e. insert at position size(list)\n \n Returns a new TreeList containing the provided element\n \n \n let list = new()\n let assert Ok(new_list) = add(list, &quot;Test&quot;)\n get(new_list, 0)\n // -&gt; Ok(&quot;Test&quot;)\n \n \nSynonyms:\nglib/treelist.add\nglib/treelist add","url":"glib/treelist.html#add"},{"doc":"glib/treelist","title":"append","content":"pub fn append(\n  tlist: TreeList(a),\n  tlist2: TreeList(a),\n) -&gt; Result(TreeList(a), Nil)\n Joins one treelist onto the end of another.\n\n ## Examples\n\n \n let assert Ok(l1) = treelist.from_list([1, 2])\n let assert Ok(l2) = treelist.from_list([3])\n let assert Ok(list) = append(l1, l2)\n to_list(list)\n // -&gt; [1, 2, 3]\n \n\nSynonyms:\nglib/treelist.append\nglib/treelist append","url":"glib/treelist.html#append"},{"doc":"glib/treelist","title":"contains","content":"pub fn contains(tlist: TreeList(a), item: a) -&gt; Bool\n Returns true if this list contains the specified element.\n \n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n contains(list, 3)\n // -&gt; True\n \n \n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n contains(list, 999)\n // -&gt; False\n \n \nSynonyms:\nglib/treelist.contains\nglib/treelist contains","url":"glib/treelist.html#contains"},{"doc":"glib/treelist","title":"do_reverse","content":"pub fn do_reverse(node: Node(a)) -&gt; Node(a)\n\nSynonyms:\nglib/treelist.do_reverse\nglib/treelist do_reverse","url":"glib/treelist.html#do_reverse"},{"doc":"glib/treelist","title":"drop","content":"pub fn drop(tlist: TreeList(a), up_to_n: Int) -&gt; TreeList(a)\n Returns a treelist that is the given treelist with up to the given number of\n elements removed from the front of the treelist.\n\n If the treelist has less than the number of elements an empty treelist is\n returned.\n\n ## Examples\n\n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n drop(list, 2)\n |&gt; to_list\n // -&gt; [3, 4]\n \n\n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n drop(list, 9)\n |&gt; to_list\n // -&gt; []\n \n\nSynonyms:\nglib/treelist.drop\nglib/treelist drop","url":"glib/treelist.html#drop"},{"doc":"glib/treelist","title":"filter","content":"pub fn filter(\n  tlist: TreeList(a),\n  filter_fn: fn(a) -&gt; Bool,\n) -&gt; TreeList(a)\n Returns a new treelist containing only the elements from the first treelist for\n which the given functions returns `True`.\n\n ## Examples\n\n \n let assert Ok(list) = from_list([2, 4, 6, 1])\n filter(list), fn(x) { x &gt; 2 })\n |&gt; to_list\n // -&gt; [4, 6]\n \n\n \n let assert Ok(list) = from_list([2, 4, 6, 1])\n filter(list), fn(x) { x &gt; 6 })\n |&gt; to_list\n // -&gt; []\n \n\nSynonyms:\nglib/treelist.filter\nglib/treelist filter","url":"glib/treelist.html#filter"},{"doc":"glib/treelist","title":"filter_map","content":"pub fn filter_map(\n  tlist: TreeList(a),\n  filter_fn: fn(a) -&gt; Result(b, c),\n) -&gt; TreeList(b)\n Returns a new treelist containing only the elements from the first treelist for\n which the given functions returns `Ok(_)`.\n\n ## Examples\n\n \n let assert Ok(list) = from_list([2, 4, 6, 1])\n filter_map(list, Error)\n // -&gt; []\n \n\n \n let assert Ok(list) = from_list([2, 4, 6, 1])\n filter_map(list, fn(x) { Ok(x + 1) })\n |&gt; to_list\n // -&gt; [3, 5, 7, 2]\n \n\nSynonyms:\nglib/treelist.filter_map\nglib/treelist filter_map","url":"glib/treelist.html#filter_map"},{"doc":"glib/treelist","title":"first","content":"pub fn first(tlist: TreeList(a)) -&gt; Result(a, Nil)\n Gets the first element from the start of the treelist, if there is one.\n\n ## Examples\n\n \n first(new())\n // -&gt; Error(Nil)\n \n\n \n let assert Ok(list) = from_list([0])\n first(list)\n // -&gt; Ok(0)\n \n\n \n let assert Ok(list) = from_list([1, 2])\n first(list)\n // -&gt; Ok(1)\n \n\nSynonyms:\nglib/treelist.first\nglib/treelist first","url":"glib/treelist.html#first"},{"doc":"glib/treelist","title":"fold","content":"pub fn fold(\n  over list: TreeList(a),\n  from initial: b,\n  with fun: fn(b, a) -&gt; b,\n) -&gt; b\n Reduces a treelist of elements into a single value by calling a given function\n on each element, going from left to right.\n\n `fold([1, 2, 3], 0, add)` is the equivalent of\n `add(add(add(0, 1), 2), 3)`.\n\nSynonyms:\nglib/treelist.fold\nglib/treelist fold","url":"glib/treelist.html#fold"},{"doc":"glib/treelist","title":"fold_right","content":"pub fn fold_right(\n  over list: TreeList(a),\n  from initial: b,\n  with fun: fn(b, a) -&gt; b,\n) -&gt; b\n Reduces a treelist of elements into a single value by calling a given function\n on each element, going from right to left.\n\n `fold_right([1, 2, 3], 0, add)` is the equivalent of\n `add(add(add(0, 3), 2), 1)`.\n \nSynonyms:\nglib/treelist.fold_right\nglib/treelist fold_right","url":"glib/treelist.html#fold_right"},{"doc":"glib/treelist","title":"from_list","content":"pub fn from_list(list: List(a)) -&gt; Result(TreeList(a), Nil)\n Takes a list and returns a new TreeList containing all the\n elements from the list in the same order as that list\n \n Returns an Error(Nil) in the case that the list is too large\n \n \n let assert Ok(list) = from_list([1,2,3])\n get(list, 1)\n // -&gt; Ok(2)\n \n \nSynonyms:\nglib/treelist.from_list\nglib/treelist from_list","url":"glib/treelist.html#from_list"},{"doc":"glib/treelist","title":"get","content":"pub fn get(list: TreeList(a), index: Int) -&gt; Result(a, Nil)\n Returns the element at the specified position in the provided treelist\n \n Returns an Error(Nil) if the index is outside the allowed range\n \n Index is zero based\n \n \n ## Examples\n \n \n let list = new()\n let assert Ok(new_list) = add(list, &quot;Test&quot;)\n get(new_list, 0)\n // -&gt; Ok(&quot;Test&quot;)\n \n \n \n new() |&gt; get(0)\n // -&gt; Error(Nil)\n \n \nSynonyms:\nglib/treelist.get\nglib/treelist get","url":"glib/treelist.html#get"},{"doc":"glib/treelist","title":"index_of","content":"pub fn index_of(tlist: TreeList(a), item: a) -&gt; Int\n Returns the index of the first occurrence of the specified element\n in this list, or -1 if this list does not contain the element.\n \n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n index_of(list, 3)\n // -&gt; 2\n \n \n \n let assert Ok(list) = from_list([1, 2, 3, 4, 2, 2])\n index_of(list, 2)\n // -&gt; 1\n \n \n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n index_of(list, 999)\n // -&gt; -1\n \n\nSynonyms:\nglib/treelist.index_of\nglib/treelist index_of","url":"glib/treelist.html#index_of"},{"doc":"glib/treelist","title":"insert","content":"pub fn insert(\n  list: TreeList(a),\n  index: Int,\n  value: a,\n) -&gt; Result(TreeList(a), Nil)\n Inserts an element at the specified index in the provided treelist\n \n Returns an Error(Nil) if the index is outside the allowed range\n \n Index is zero based\n \n Returns a new TreeList containing the provided element\n \n \n let list = new()\n let assert Ok(new_list) = insert(list, 0, &quot;Test&quot;)\n get(new_list, 0)\n // -&gt; Ok(&quot;Test&quot;)\n \n \n \n let list = new()\n insert(list, 1, &quot;Test&quot;)\n // -&gt; Error(Nil)\n \n \nSynonyms:\nglib/treelist.insert\nglib/treelist insert","url":"glib/treelist.html#insert"},{"doc":"glib/treelist","title":"last","content":"pub fn last(tlist: TreeList(a)) -&gt; Result(a, Nil)\n Gets the last element from the start of the treelist, if there is one.\n\n ## Examples\n\n \n last(new())\n // -&gt; Error(Nil)\n \n\n \n let assert Ok(list) = from_list([0])\n last(list)\n // -&gt; Ok(0)\n \n\n \n let assert Ok(list) = from_list([1, 2])\n last(list)\n // -&gt; Ok(2)\n \n\nSynonyms:\nglib/treelist.last\nglib/treelist last","url":"glib/treelist.html#last"},{"doc":"glib/treelist","title":"last_index_of","content":"pub fn last_index_of(tlist: TreeList(a), item: a) -&gt; Int\n Returns the index of the last occurrence of the specified element\n in this list, or -1 if this list does not contain the element.\n \n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n last_index_of(list, 3)\n // -&gt; 2\n \n \n \n let assert Ok(list) = from_list([1, 2, 3, 4, 2, 2])\n last_index_of(list, 2)\n // -&gt; 5\n \n \n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n last_index_of(list, 999)\n // -&gt; -1\n \n\nSynonyms:\nglib/treelist.last_index_of\nglib/treelist last_index_of","url":"glib/treelist.html#last_index_of"},{"doc":"glib/treelist","title":"map","content":"pub fn map(\n  tlist: TreeList(a),\n  filter_fn: fn(a) -&gt; b,\n) -&gt; TreeList(b)\n Returns a new treelist containing only the elements of the first list after \n the function has been applied to each one.\n\n ## Examples\n\n \n let assert Ok(list) = from_list([2, 4, 6])\n map(list, fn(x) { x * 2 })\n |&gt; to_list\n // -&gt; [4, 8, 12]\n \n\nSynonyms:\nglib/treelist.map\nglib/treelist map","url":"glib/treelist.html#map"},{"doc":"glib/treelist","title":"new","content":"pub fn new() -&gt; TreeList(a)\n Creates an empty treelist\nSynonyms:\nglib/treelist.new\nglib/treelist new","url":"glib/treelist.html#new"},{"doc":"glib/treelist","title":"remove","content":"pub fn remove(\n  list: TreeList(a),\n  index: Int,\n) -&gt; Result(#(a, TreeList(a)), Nil)\n Removes an element at the specified index in the provided treelist\n \n Returns an Error(Nil) if the index is outside the allowed range\n \n Index is zero based\n \n Returns a tuple containing the value at the specified index and the new TreeList\n \n \n let list = new()\n let assert Ok(new_list) = insert(list, 0, &quot;Test&quot;)\n get(new_list, 0)\n // -&gt; Ok(&quot;Test&quot;)\n remove(new_list, 0)\n // -&gt; #(&quot;Test&quot;, TreeList(..))\n \n \n \n let list = new()\n remove(list, 1)\n // -&gt; Error(Nil)\n \n \nSynonyms:\nglib/treelist.remove\nglib/treelist remove","url":"glib/treelist.html#remove"},{"doc":"glib/treelist","title":"repeat","content":"pub fn repeat(\n  item a: a,\n  times times: Int,\n) -&gt; Result(TreeList(a), Nil)\n Builds a list of a given value a given number of times.\n\n ## Examples\n\n \n repeat(&quot;a&quot;, times: 0)\n // -&gt; new()\n \n\n \n repeat(&quot;a&quot;, times: 5)\n |&gt; to_list\n // -&gt; [&quot;a&quot;, &quot;a&quot;, &quot;a&quot;, &quot;a&quot;, &quot;a&quot;]\n \n\nSynonyms:\nglib/treelist.repeat\nglib/treelist repeat","url":"glib/treelist.html#repeat"},{"doc":"glib/treelist","title":"rest","content":"pub fn rest(tlist: TreeList(a)) -&gt; Result(TreeList(a), Nil)\n Returns a new treelist minus the first element. If the treelist is empty, \n `Error(Nil)` is returned.\n\n\n ## Examples\n\n \n rest(new())\n // -&gt; Error(Nil)\n \n\n \n let assert Ok(list) = from_list([0])\n rest(list)\n // -&gt; Ok([])\n \n\n \n let assert Ok(list) = from_list([1, 2])\n rest(list)\n // -&gt; Ok([2])\n \n\nSynonyms:\nglib/treelist.rest\nglib/treelist rest","url":"glib/treelist.html#rest"},{"doc":"glib/treelist","title":"reverse","content":"pub fn reverse(tlist: TreeList(a)) -&gt; TreeList(a)\n Creates a new treelist from a given treelist containing the same elements but in the\n opposite order.\n\n ## Examples\n\n \n reverse(new())\n |&gt; to_list\n // -&gt; []\n \n\n \n let assert Ok(list) = from_list([1])\n reverse(list)\n |&gt; to_list\n // -&gt; [1]\n \n\n \n let assert Ok(list) = from_list([1, 2])\n reverse(list)\n |&gt; to_list\n // -&gt; [2, 1]\n \n\nSynonyms:\nglib/treelist.reverse\nglib/treelist reverse","url":"glib/treelist.html#reverse"},{"doc":"glib/treelist","title":"set","content":"pub fn set(\n  list: TreeList(a),\n  index: Int,\n  value: a,\n) -&gt; Result(TreeList(a), Nil)\n Updates the element at index specified in the provided treelist\n \n Returns an Error(Nil) if the index is outside the allowed range\n \n Index is zero based\n \n Returns a new TreeList containing the updated node\n \n \n let list = new()\n let assert Ok(new_list) = add(list, &quot;Test&quot;)\n get(new_list, 0)\n // -&gt; Ok(&quot;Test&quot;)\n let assert Ok(new_list) = set(list, 0, &quot;Updated&quot;)\n get(new_list, 0)\n // -&gt; Ok(&quot;Updated&quot;)\n \n \nSynonyms:\nglib/treelist.set\nglib/treelist set","url":"glib/treelist.html#set"},{"doc":"glib/treelist","title":"size","content":"pub fn size(list: TreeList(a)) -&gt; Int\n Returns the number of elements in the provided treelist\nSynonyms:\nglib/treelist.size\nglib/treelist size","url":"glib/treelist.html#size"},{"doc":"glib/treelist","title":"take","content":"pub fn take(tlist: TreeList(a), up_to_n: Int) -&gt; TreeList(a)\n Returns a treelist containing the first given number of elements from the given\n treelist.\n\n If the treelist has less than the number of elements then the full treelist is\n returned.\n\n\n ## Examples\n\n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n take(list, 2)\n |&gt; to_list\n // -&gt; [1, 2]\n \n\n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n take(list, 9)\n |&gt; to_list\n // -&gt; [1, 2, 3, 4]\n \n\nSynonyms:\nglib/treelist.take\nglib/treelist take","url":"glib/treelist.html#take"},{"doc":"glib/treelist","title":"to_iterator","content":"pub fn to_iterator(tlist: TreeList(a)) -&gt; Yielder(a)\n Creates an iterator that yields each element from the given treelist.\n\n\n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n to_iterator(list)\n |&gt; to_list\n // -&gt; [1, 2, 3, 4]\n \n\nSynonyms:\nglib/treelist.to_iterator\nglib/treelist to_iterator","url":"glib/treelist.html#to_iterator"},{"doc":"glib/treelist","title":"to_iterator_reverse","content":"pub fn to_iterator_reverse(tlist: TreeList(a)) -&gt; Yielder(a)\n Creates an iterator that yields each element from the given treelist.\n\n\n \n let assert Ok(list) = from_list([1, 2, 3, 4])\n to_iterator_reverse(list)\n |&gt; to_list\n // -&gt; [4, 3, 2, 1]\n \n\nSynonyms:\nglib/treelist.to_iterator_reverse\nglib/treelist to_iterator_reverse","url":"glib/treelist.html#to_iterator_reverse"},{"doc":"glib/treelist","title":"to_list","content":"pub fn to_list(l: TreeList(a)) -&gt; List(a)\n Converts a TreeList into a standard Gleam list\n \n \n let list = new()\n let assert Ok(new_list) = insert(list, 0, &quot;Test&quot;)\n let assert Ok(new_list2) = insert(new_list, 1, &quot;Second&quot;)\n to_list(new_list2)\n // -&gt; [&quot;Test&quot;, &quot;Second&quot;]\n \n \nSynonyms:\nglib/treelist.to_list\nglib/treelist to_list","url":"glib/treelist.html#to_list"},{"doc":"glib/treelist","title":"try_map","content":"pub fn try_map(\n  tlist: TreeList(a),\n  filter_fn: fn(a) -&gt; Result(b, c),\n) -&gt; Result(TreeList(b), c)\n Takes a function that returns a `Result` and applies it to each element in a\n given treelist in turn.\n\n If the function returns `Ok(new_value)` for all elements in the treelist then a\n treelist of the new values is returned.\n\n If the function returns `Error(reason)` for any of the elements then it is\n returned immediately. None of the elements in the treelist are processed after\n one returns an `Error`.\n\n ## Examples\n\n \n let assert Ok(list) = from_list([1, 2, 3])\n let assert Ok(tl) = try_map(list, fn(x) { Ok(x + 2) })\n treelist.to_list(tl)\n // -&gt; [3, 4, 5]\n \n\n \n let assert Ok(list) = from_list([1, 2, 3])\n try_map(list, fn(_) { Error(0) })\n // -&gt; Error(0)\n \n\n \n let assert Ok(list) = from_list([[1], [2, 3]])\n let assert Ok(tl) = try_map(list, first)\n treelist.to_list(tl)\n // -&gt; Ok([1, 2])\n \n\n \n let assert Ok(list) = from_list([[1], [], [2]])\n try_map(list, first)\n // -&gt; Error(Nil)\n \n\nSynonyms:\nglib/treelist.try_map\nglib/treelist try_map","url":"glib/treelist.html#try_map"},{"doc":"glib/treelist","title":"wrap","content":"pub fn wrap(val: a) -&gt; TreeList(a)\n Returns the given item wrapped in a list.\n\n ## Examples\n\n \n wrap(1)\n |&gt; to_list\n // -&gt; [1]\n\n wrap([&quot;a&quot;, &quot;b&quot;, &quot;c&quot;])\n |&gt; to_list\n // -&gt; [[&quot;a&quot;, &quot;b&quot;, &quot;c&quot;]]\n\n wrap([[]])\n |&gt; to_list\n // -&gt; [[[]]]\n \n\n\nSynonyms:\nglib/treelist.wrap\nglib/treelist wrap","url":"glib/treelist.html#wrap"},{"doc":"glib/treelist","title":"glib/treelist","content":" TreeLists are ordered sequence of elements stored in an efficient binary\n tree structure\n \n New elements can be added at any index of the structure and will\n be stored efficiently with O(log n) complexity\n \n Based on https://en.wikipedia.org/wiki/AVL_tree\n ","url":"glib/treelist.html"},{"doc":"glib/map","title":"Map","content":"pub opaque type Map(value)\n\n\nSynonyms:\nglib/map.Map\nglib/map Map","url":"glib/map.html#Map"},{"doc":"glib/map","title":"clear","content":"pub fn clear(previous_map: Map(a)) -&gt; Result(Map(a), Nil)\n Creates a new empty map with the same sizing/loading properties as the\n passed map\nSynonyms:\nglib/map.clear\nglib/map clear","url":"glib/map.html#clear"},{"doc":"glib/map","title":"contains_key","content":"pub fn contains_key(map: Map(a), key: String) -&gt; Bool\n Returns the existence in the map for the stored key\n \n \n ## Examples\n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; contains_key(&quot;key&quot;)\n // -&gt; True\n \n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; contains_key(&quot;non-existent&quot;)\n // -&gt; False\n \n \nSynonyms:\nglib/map.contains_key\nglib/map contains_key","url":"glib/map.html#contains_key"},{"doc":"glib/map","title":"entries","content":"pub fn entries(map: Map(a)) -&gt; List(#(String, a))\n Returns a list of the tuples #(key, value) contained in the map\n \n ## Examples\n \n \n new() |&gt; entries\n // -&gt; []\n \n \n  gleam\n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; entries\n // -&gt; [#(&quot;key&quot;, &quot;value&quot;)]\n \n \nSynonyms:\nglib/map.entries\nglib/map entries","url":"glib/map.html#entries"},{"doc":"glib/map","title":"full_count","content":"pub fn full_count(map: Map(a)) -&gt; Int\n Returns a count of the number of entries in the map\n This is used for testing to compare against the cached size\n Performs a full iteration of the list incrementing for all Some(_)\n entries\nSynonyms:\nglib/map.full_count\nglib/map full_count","url":"glib/map.html#full_count"},{"doc":"glib/map","title":"get","content":"pub fn get(map: Map(a), key: String) -&gt; Result(Option(a), Nil)\n Retrieves the option wrapped value from the map for the stored key\n \n The key may not exist so then None is returned\n \n ## Examples\n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; get(&quot;key&quot;)\n // -&gt; Ok(&quot;value&quot;)\n \n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; get(&quot;non-existent&quot;)\n // -&gt; None\n \n \nSynonyms:\nglib/map.get\nglib/map get","url":"glib/map.html#get"},{"doc":"glib/map","title":"is_empty","content":"pub fn is_empty(map: Map(a)) -&gt; Bool\n Determines whether the map is empty, i.e. contains no key/values\n \n ## Examples\n \n \n new() |&gt; is_empty\n // -&gt; True\n \n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; is_empty\n // -&gt; False\n \n \nSynonyms:\nglib/map.is_empty\nglib/map is_empty","url":"glib/map.html#is_empty"},{"doc":"glib/map","title":"keys","content":"pub fn keys(map: Map(a)) -&gt; List(String)\n Returns a list of the keys contained in the map\n \n ## Examples\n \n \n new() |&gt; keys\n // -&gt; []\n \n \n  gleam\n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; keys\n // -&gt; [&quot;key&quot;]\n \n \nSynonyms:\nglib/map.keys\nglib/map keys","url":"glib/map.html#keys"},{"doc":"glib/map","title":"list_size","content":"pub fn list_size(map: Map(a)) -&gt; Int\n Returns the internal storage size of the map\n This is mainly for testing use\nSynonyms:\nglib/map.list_size\nglib/map list_size","url":"glib/map.html#list_size"},{"doc":"glib/map","title":"new","content":"pub fn new() -&gt; Result(Map(a), Nil)\n Creates an empty map\n The size and loading factor are set to the default\n The size is the starting size for the list that contains the values\n The loading factor is the value 0 -&gt; 1 that determines when the\n list is resized. This is the percentage of the backing list that is filled.\n For example, if the loading factor was 0.5 then when one half of the backing\n list is populated, the next addition to the Map will trigger a resize to\n ensure the map has usable space\nSynonyms:\nglib/map.new\nglib/map new","url":"glib/map.html#new"},{"doc":"glib/map","title":"new_with_size","content":"pub fn new_with_size(size: Int) -&gt; Result(Map(a), Nil)\n Creates an empty map with specified size\n The loading factor is set to default\nSynonyms:\nglib/map.new_with_size\nglib/map new_with_size","url":"glib/map.html#new_with_size"},{"doc":"glib/map","title":"new_with_size_and_load","content":"pub fn new_with_size_and_load(\n  size: Int,\n  load: Float,\n) -&gt; Result(Map(a), Nil)\n Creates an empty map with specified size and loading factor\n load is a value 0-&gt;1 (non-inclusive) which specifies a percentage (e.g. 0.5 is 50%)\n at which point the backing list is resized\n This should be kept around 0.6-0.8 to avoid either excessive resizing or\n excessive key hash collisions\nSynonyms:\nglib/map.new_with_size_and_load\nglib/map new_with_size_and_load","url":"glib/map.html#new_with_size_and_load"},{"doc":"glib/map","title":"put","content":"pub fn put(\n  map: Map(a),\n  key: String,\n  value: a,\n) -&gt; Result(Map(a), Nil)\n Inserts a value into the map with the given key\n \n Will replace value if key already exists\n \n ## Examples\n \n \n new() |&gt; put(&quot;key&quot;, 999) |&gt; to_string(fn(i) { int.to_string(i) })\n // -&gt; {&quot;key&quot;:999}\n \n \n \n new() |&gt; put(&quot;key&quot;, 999) |&gt; put(&quot;key2&quot;, 111) |&gt; to_string(fn(i) { int.to_string(i) })\n // -&gt; {&quot;key&quot;:999, &quot;key2&quot;:111}\n \n \n \n new() |&gt; put(&quot;key&quot;, 999) |&gt; put(&quot;key&quot;, 123) |&gt; to_string(fn(i) { int.to_string(i) })\n // -&gt; {&quot;key&quot;:123}\n \n \nSynonyms:\nglib/map.put\nglib/map put","url":"glib/map.html#put"},{"doc":"glib/map","title":"remove","content":"pub fn remove(\n  map: Map(a),\n  key: String,\n) -&gt; Result(#(Option(a), Map(a)), Nil)\n Removes the specified key from the map and returns a tuple containing\n the removed option wrapped value or None and the altered map without the\n specified key\n \n ## Examples\n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; remove(&quot;key&quot;)\n // -&gt; #(Some(&quot;value&quot;), {})\n \n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; remove(&quot;non-existent&quot;)\n // -&gt; #(None, {&quot;key&quot;: &quot;value&quot;})\n \nSynonyms:\nglib/map.remove\nglib/map remove","url":"glib/map.html#remove"},{"doc":"glib/map","title":"size","content":"pub fn size(map: Map(a)) -&gt; Int\n Determines the size of the map, i.e. the number of key/values\n \n ## Examples\n \n \n new() |&gt; size\n // -&gt; 0\n \n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; size\n // -&gt; 1\n \n \nSynonyms:\nglib/map.size\nglib/map size","url":"glib/map.html#size"},{"doc":"glib/map","title":"to_string","content":"pub fn to_string(\n  map: Map(a),\n  value_to_string: fn(a) -&gt; String,\n) -&gt; Result(String, Nil)\n Returns a string representation of the passed map\n Requires a value_to_string fn to generate the output\n \n ## Examples\n \n \n new() |&gt; to_string(fn(v) { v })\n // -&gt; {}\n \n \n \n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; to_string(fn(v) { v })\n // -&gt; {&quot;key&quot;: &quot;value&quot;}\n \n \nSynonyms:\nglib/map.to_string\nglib/map to_string","url":"glib/map.html#to_string"},{"doc":"glib/map","title":"values","content":"pub fn values(map: Map(a)) -&gt; List(a)\n Returns a list of the values contained in the map\n \n ## Examples\n \n \n new() |&gt; values\n // -&gt; []\n \n \n  gleam\n new() |&gt; put(&quot;key&quot;, &quot;value&quot;) |&gt; values\n // -&gt; [&quot;value&quot;]\n \n \nSynonyms:\nglib/map.values\nglib/map values","url":"glib/map.html#values"},{"doc":"glib/map","title":"glib/map","content":" Maps are a structure similar to dict in that they map keys to values.\n Duplicate keys cannot exist and a key can map to at most one value\n \n The Keys are strings, values can be any type but values must be of the same type\n \n Maps are unordered","url":"glib/map.html"}]);